aboutsummaryrefslogtreecommitdiffstats
path: root/cli/bash-completion.sh
diff options
context:
space:
mode:
Diffstat (limited to 'cli/bash-completion.sh')
-rw-r--r--cli/bash-completion.sh74
1 files changed, 56 insertions, 18 deletions
diff --git a/cli/bash-completion.sh b/cli/bash-completion.sh
index bbef124..e1c6424 100644
--- a/cli/bash-completion.sh
+++ b/cli/bash-completion.sh
@@ -20,15 +20,53 @@ _icevault() {
COMPREPLY=()
declare -a files
- local opts="--debug -h --help -p --show-passwords -s --socket= --version"
- local args="fill insert dump clip edit ls"
- local OPTIND IFS
- # find out if our $cur is an optional argument or a command
- for (( OPTIND = 1; OPTIND < cword; OPTIND++ )); do
+ local cmd firstopt=2 opts nargs
+ if [ $cword -eq 1 -a -z "$cur" ] || [[ "${words[1]}" =~ :// ]] || [[ "${words[1]}" =~ ^- ]]; then
+ firstopt=1
+ cmd=fill # default command
+ elif [ $cword -gt 1 ]; then
+ cmd="${words[1]}"
+ fi
+
+ local commands='fill clip cp dump edit git insert ls mv reencrypt rm'
+ case "$cmd" in
+ fill) opts='-f --force -p --show-passwords -s --socket='; nargs=1;;
+ clip) opts=; nargs=1 ;;
+ cp) opts='-f --force'; nargs=2;;
+ dump) opts='-p --show-passwords'; nargs=1;;
+ edit) opts=; nargs=1 ;;
+ git) opts= ;;
+ insert) opts='-f --force -s --socket='; nargs=0;;
+ ls) opts='-0 --zero -r --recursive'; nargs=-1;;
+ mv) opts='-f --force'; nargs=2;;
+ reencrypt) opts=; nargs=-1 ;;
+ rm) opts='-f --force -r --recursive'; nargs=-1;;
+ esac
+ opts="${opts:+$opts }--debug -? --help --version"
+
+ if [ "$cmd" = git ]; then
+ # use bash completion for git by ignoring the first word ('icevault')
+ [ -f /usr/share/bash-completion/completions/git ] && . /usr/share/bash-completion/completions/git || return
+ COMP_CWORD=$(( $COMP_CWORD - 1 ))
+ COMP_WORDS=( "${COMP_WORDS[@]:1}" )
+ local GIT_DIR GIT_WORK_TREE # fetch store and git-dir from the config-file
+ GIT_WORK_TREE=$(sed -n '/^store\s*=\s*/{s///p;q}' "${XDG_CONFIG_HOME:-$HOME/.config}/icevault")
+ GIT_WORK_TREE=$( echo "${GIT_WORK_TREE:-icevault}" | sed -re "s@^~/@$HOME@; t; s@^/@/@; t; s@^@${XDG_DATA_HOME:-$HOME/.local/share}/@" )
+ GIT_DIR=$(sed -n '/^git-dir\s*=\s*/{s///p;q}' "${XDG_CONFIG_HOME:-$HOME/.config}/icevault")
+ GIT_DIR=$( echo "${GIT_DIR:-.git}" | sed -re "s@^~/@$HOME@; t; s@^/@/@; t; s@^@$GIT_WORK_TREE/@" )
+ export GIT_DIR GIT_WORK_TREE
+ _git
+ return
+ fi
+
+ local OPTIND socket
+ # find out if our $cur is an optional argument or not
+ for (( OPTIND = firstopt; OPTIND < cword; OPTIND++ )); do
case "${words[OPTIND]}" in
- -s) (( OPTIND++ ));;
+ -s) (( OPTIND++ )); [ $OPTIND -lt $cword ] && socket="${words[OPTIND]}";;
--) break;;
+ --socket=*) [ $OPTIND -lt $cword ] && socket="${words[OPTIND]#--socket=}";;
-*) ;;
*) break;;
esac
@@ -45,20 +83,19 @@ _icevault() {
[ -d "$p" -o -S "$p" ] && COMPREPLY+=( "$p" )
done
return
+ elif [[ $OPTIND -eq $cword && "$cur" =~ ^- ]]; then
+ COMPREPLY+=( $(compgen -W "$opts" -- "$cur") )
+ [ "${#COMPREPLY[@]}" -eq 1 -a "${COMPREPLY[0]}" = '--socket=' ] && compopt -o nospace
+ return
fi
- # complete options and commands
- if [ $OPTIND -eq $cword -a "$cur" ]; then
- COMPREPLY+=( $(compgen -W "$opts $args" -- "$cur") )
- [ "${#COMPREPLY[@]}" -eq 1 -a "${COMPREPLY[0]}" = --socket= ] && compopt -o nospace
- fi
- [ $(($OPTIND + 1)) -lt $cword ] && return
-
local trim=
- if [ -z "$cur" -a $(($OPTIND + 1)) -eq $cword -a "${words[OPTIND]}" = insert ]; then
+ if [ "$cmd" = fill -a \( $OPTIND -eq $cword -o $(( $OPTIND + 1)) -eq $cword \) -a -z "$cur" ]; then
+ cur="$(icevault _geturi ${socket:+--socket="$socket"})"/ # get URI from webpage
+ elif [ -z "$cmd" -a "$cword" -eq 1 -a "$cur" ]; then
+ # autocomplete command
+ COMPREPLY+=( $(compgen -W "$commands" -- "$cur") )
return
- elif [ -z "$cur" -a $OPTIND -eq $cword ] || [ -z "$cur" -a $(($OPTIND + 1)) -eq $cword -a "${words[OPTIND]}" = fill ]; then
- cur="$(icevault _geturi)"/ # get URI from webpage
else
cur=$(dequote "$cur")
# trim words with : or = in $COMP_WORDBREAKS; see __ltrim_colon_completions
@@ -72,13 +109,14 @@ _icevault() {
fi
local uri
- if [[ $OPTIND -eq $cword || ! "${words[OPTIND]}" =~ :// ]]; then
+ # autocomplete with identities as long as we don't exeed $nargs
+ if [ $nargs -lt 0 -o $(($cword - $OPTIND + 1)) -le $nargs ]; then
compopt -o filenames -o noquote
while read -r -d $'\0' uri; do
# quote manually (so we don't quote the : and =)
uri=$( echo "${uri#$trim}" | sed "s/[][\\{}*?~<>;'\"|&()\!$\` \t]/\\\\&/g" )
COMPREPLY+=( "$uri" )
- done < <(icevault -0 _complete "$cur")
+ done < <(icevault _complete -0 "$cur" 2>/dev/null)
[ "${#COMPREPLY[@]}" -eq 1 -a "${COMPREPLY[0]: -1:1}" = / ] && compopt -o nospace
return 0
fi